// EE231002 Lab07. Magic Square
// 108061112, 林靖
// SIZEov. 2, 2019

#include <stdio.h>
#define TRUE 1
#define FALSE 0
#define SIZE 4
#define UNFILLED 0

typedef int BOOL;

int g_count;
int g_array[SIZE][SIZE];
int g_target_sum;
void solve_unfilled_or_print(void);


int main(void)
{
	int i, j;

	for (j = 0; j < SIZE; j++) {
		for (i = 0; i < SIZE; i++) {
			scanf("%d", &g_array[i][j]);
		}
	}
	g_target_sum = SIZE * (SIZE * SIZE + 1) / 2;
	solve_unfilled_or_print();
	printf("Number of solutions found: %d\n", g_count);
	return 0;
}


void solve_unfilled_or_print(void)
{
	BOOL found_unfilled;
	BOOL is_legal;
	int row, column;
	int i, j;
	int tentative;
	int sum;

	found_unfilled = FALSE;
	row = 0;
	for (row = 0; row < SIZE && !found_unfilled; row++) {
		for (column = 0; column < SIZE && !found_unfilled; column++) {
			if (g_array[row][column] == UNFILLED) {
				found_unfilled = TRUE;
			}
		}
	}
	row--;
	column--;
	if (!found_unfilled) {
		printf("Solution %d:\n", ++g_count);
		for (i = 0; i < SIZE; i++) {
			for (j = 0; j < SIZE; j++) {
				printf("%4d", g_array[i][j]);
			}
			printf("\n");
		}
		printf("\n");
	}
	for (tentative = SIZE * SIZE; tentative > 0; tentative--) {
		is_legal = TRUE;
		for (i = 0; is_legal && i < SIZE; i++) {
			for (j = 0; is_legal && j < SIZE; j++) {
				if (g_array[i][j] == tentative) {
					is_legal = FALSE;
				}
			}
		}
		if (is_legal) {
			sum = 0;
			for (i = 0; i < SIZE; i++) {
				sum += g_array[i][column];
			}
			if (sum != g_target_sum) {
				is_legal = FALSE;
			}
		}
		if (is_legal) {
			sum = 0;
			for (j = 0; j < SIZE; j++) {
				sum += g_array[row][j];
			}
			if (sum != g_target_sum) {
				is_legal = FALSE;
			}
		}
		if (is_legal) {
			sum = 0;
			for (i = 0, j = 0; i < SIZE; i++, j++) {
				sum += g_array[i][j];
			}
			if (sum != g_target_sum) {
				is_legal = FALSE;
			}
		}
		if (is_legal) {
			sum = 0;
			for (i = 0, j = SIZE - 1; i < SIZE; i++, j--) {
				sum += g_array[i][j];
			}
			if (sum != g_target_sum) {
				is_legal = FALSE;
			}
		}
		if (is_legal) {
			solve_unfilled_or_print();
		} else {
			g_array[row][column] = UNFILLED;
		}
	}
	return;
}

